;-----------------------------------------------------------------------
;  Copyright  NetworkDLS 2002, All rights reserved
;
; THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
; ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
; THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
; PARTICULAR PURPOSE.
;-----------------------------------------------------------------------

[Setup]
;-- Main Setup Information
 AppName                  = SQL-Exchange Client x86
 AppVerName               = SQL-Exchange Client x86 1.0.5.8
 AppCopyright             = Copyright  1995-2006 NetworkDLS
 DefaultDirName           = {pf}\NetworkDLS\SQL-Exchange\Client x86
 DefaultGroupName         = NetworkDLS\SQL-Exchange Client x86
 UninstallDisplayIcon     = {app}\SQLEClient.Exe
 WizardImageFile          = Resources\LgSetup.bmp
 WizardSmallImageFile     = Resources\SmSetup.bmp
 PrivilegesRequired       = PowerUser
 Uninstallable            = Yes
 AppMutex                 = SQL-Exchange Client x86
 LicenseFile              = Resources\EULA.txt
 Compression              = BZIP/9
 OutputBaseFilename       = "..\..\Binary\SQLEClient x86 1.0.5.8"
;UninstallLogMode         = OverWrite
 UninstallRestartComputer = Yes
 DisableStartupPrompt     = Yes
 DirExistsWarning         = No

;-- Windows 2000 & XP (Support Dialog)
 AppPublisher    = NetworkDLS
 AppPublisherURL = http://www.NetworkDLS.com/
 AppUpdatesURL   = http://www.NetworkDLS.com/
 AppVersion      = 1.0.5.8

[Tasks]
 Name: CreateShortcuts; Description: "Create shortcut icons"; GroupDescription: "Additional icons:";

[Files]
 Source: "..\Binary\Win32\SQLEClient.Exe";            DestDir: "{app}";     Flags: IgnoreVersion RestartReplace;
 Source: "..\Binary\Win32\AutoUpdate.Exe";            DestDir: "{app}";     Flags: IgnoreVersion;

 Source: "Resources\EULA.txt";                        DestDir: "{app}";     Flags: IgnoreVersion;
 Source: "Resources\OpenDlg.ico";                     DestDir: "{app}";     Flags: IgnoreVersion;
 Source: "Resources\Start.ico";                       DestDir: "{app}";     Flags: IgnoreVersion;
 Source: "Resources\Stop.ico";                        DestDir: "{app}";     Flags: IgnoreVersion;
 Source: "Resources\OpenCon.ico";                     DestDir: "{app}";     Flags: IgnoreVersion;

 Source: "SQL\SQLExch_Statements.sql";                DestDir: "{app}\SQL"; Flags: IgnoreVersion;
 Source: "SQL\SQLExch_Create_DB.sql";                 DestDir: "{app}\SQL"; Flags: IgnoreVersion;

 Source: "..\SharedSource\EventMsg\EventMsg.dll";     DestDir: "{app}";     Flags: IgnoreVersion;

[Icons]
 Name: "{group}\Open Client";     Filename: "{app}\SQLEClient.Exe";  WorkingDir: "{app}"; Parameters: "/OpenMainDialog"; IconFilename: "{app}\OpenDlg.ico";
;Name: "{group}\Open Console";    Filename: "{app}\SQLEClient.Exe";  WorkingDir: "{app}"; Parameters: "/OpenConsole";    IconFilename: "{app}\OpenCon.ico";
 Name: "{group}\Start Service";   Filename: "{app}\SQLEClient.Exe";  WorkingDir: "{app}"; Parameters: "/Start";          IconFilename: "{app}\Start.ico";
 Name: "{group}\Stop Service";    Filename: "{app}\SQLEClient.Exe";  WorkingDir: "{app}"; Parameters: "/Stop";           IconFilename: "{app}\Stop.ico";
 Name: "{group}\Run StandAlone";  Filename: "{app}\SQLEClient.Exe";  WorkingDir: "{app}"; Parameters: "/NonService";     IconFilename: "{app}\SQLEClient.exe"; IconIndex: 0;

[Dirs]
 Name: "{app}\Logs"
 Name: "{app}\Temp"
 Name: "{app}\DB"
 
[Registry]
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; Flags: UninsDeleteKey

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "Path";              ValueType: String; ValueData: "{app}";                     Flags: CreateValueIfDoesntExist;

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SQLDataFiles";      ValueType: String; ValueData: "{app}\DB";                  Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "DefaultDBO";        ValueType: String; ValueData: "DBO";                       Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "ReplicationDB";     ValueType: String; ValueData: "SQLExch_Replication";       Flags: CreateValueIfDoesntExist;

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SessionLogDir";     ValueType: String; ValueData: "{app}\Logs";                Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "TempFilesPath";     ValueType: String; ValueData: "{app}\Temp";                Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SQLDriver";         ValueType: String; ValueData: "{{SQL Server}";             Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SQLPassword";       ValueType: Binary; ValueData: "";                          Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SQLServer";         ValueType: String; ValueData: "";                          Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "SQLUserID";         ValueType: String; ValueData: "sa";                        Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "CompanyName";       ValueType: String; ValueData: "";                          Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "CompanyPassword";   ValueType: Binary; ValueData: "";                          Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "ServerAddress";     ValueType: String; ValueData: "SQLExch.com";
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "ShowSplashScreen";  ValueType: Dword;  ValueData: "1";                         Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "CacheLogFile";      ValueType: Dword;  ValueData: "1";                         Flags: CreateValueIfDoesntExist;

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "AuthString";        ValueType: String; ValueData: "trIeSPiUhouDlUwRLe5hie2H5awRoupiaDi8zI0fo3Y7u6R703r7e6rLacrouChi";
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "AuthKey";           ValueType: String; ValueData: "6riupiekieB8uphiuspi0tr6azl2piAth6us6ieko2zoap2818UviapHlEvo5joe";

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "ServerPort";        ValueType: Dword;  ValueData: "6676";
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "ConnectInterval";   ValueType: Dword;  ValueData: "10";
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "PingTimeoutMS";     ValueType: Dword;  ValueData: "60000";

 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "TimeWindowBegin";   ValueType: Dword;  ValueData: "32400";
 Root: HKLM; Subkey: "Software\NetworkDLS\SQL-Exchange\Client x86"; ValueName: "TimeWindowEnd";     ValueType: Dword;  ValueData: "61200";

;--Create registry keys and values for Event Logs
 Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\Eventlog\SQL-Exchange\SQL-Exchange (Client) x86"; Flags: UninsDeleteKey

 Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\Eventlog\SQL-Exchange\SQL-Exchange (Client) x86"; ValueName: "TypesSupported";        ValueType: Dword;  ValueData: "7";                   Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\Eventlog\SQL-Exchange\SQL-Exchange (Client) x86"; ValueName: "EventMessageFile";      ValueType: String; ValueData: "{app}\EventMsg.dll";  Flags: CreateValueIfDoesntExist;

[Run]
 Filename: "{app}\SQLEClient.Exe"; Parameters: "/install";
 Filename: "{app}\SQLEClient.Exe"; Parameters: "/start";

[UninstallRun]
 Filename: "{app}\SQLEClient.Exe"; Parameters: "/delete"; RunOnceId: "DeleteService"; MinVersion: 0, 4.0

