///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef NetworkDLS_Algorithmic_Symmetric_Cipher_Cryptography_Library_CCode_H
#define NetworkDLS_Algorithmic_Symmetric_Cipher_Cryptography_Library_CCode_H
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class NASCCL{
public:
	bool InitializeCryptographyEx(void *lpKey, unsigned int iKeySz, bool bINAutoReset);
	bool InitializeCryptography(const char *sKey, bool bINAutoReset);
	void DestroyCryptography(void);
	void CipherEx(void *lpBuf, void *lpTarget, unsigned int iBufSz);
	void Cipher(void *lpBuf, unsigned int iBufSz);
	void ResetCryptography(void);
	void MutateKey(void);

	bool bAutoReset;

	void BuildSBox(void);

	unsigned char *sKeyBuf;
	unsigned int iKeySz;
	unsigned int iKeyPos;
	unsigned int iSBox;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
